;	PROCESSOR	PIC16F84A
;	INCLUDE		<P16F84A.INC>
;


	list      p=16f628A           ; list directive to define processor
	#include <p16F628A.inc>       ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

	RADIX		HEX


	__CONFIG   _CP_OFF & _LVP_OFF & _BOREN_OFF & _MCLRE_ON & _WDT_OFF & _PWRTE_ON & _INTOSC_OSC_NOCLKOUT 


;	CBLOCK	0Ch

	CBLOCK 0X20

;*******************************
; 16 LED Charactor Moving Design
;Using Pic16F84A
;Shifting Led's using two CD4017 
;Written By 4S5 AS
;2008-04-20
;http://www.manelsoft.com/projects/pic16f84a_matrix_led_display.aspx
;*******************************

DEL
DEL1
C0
C1
C2
C3
C4
C5
C6
C7
C8
C9
C10
C11
C12
C13
C14
C15
C16
C17
C18
C19
C20
C21
C22
C23
C24
C25
C26
C27
C28
C29
C30
C31
C32
C33
C34
C35
C36
C37
C38
C39
C40
C41
C42
C43
C44
C45
C46
C47
C48
C49
C50
C51
C52
C53
C54
C55
C56
C57
C58
C59
C60
C61
C62
C63
C64
TIME
	ENDC

#DEFINE CLK1		PORTA,1; Connect  Clock pin of  CD4017 
#DEFINE CLK2		PORTA,2; Connect  Clock pin of  CD4017 
#DEFINE CLR		PORTA,0; Connect  RESET pin of  CD4017 

	ORG	0000h
	BCF	STATUS,RP0
	GOTO	MAIN

RESET	BSF		CLR
		GOTO 	$+.1
		BCF	 CLR
		RETURN

DELAY		MOVWF PORTB
			BCF	CLK1
			DECFSZ	DEL,1
			GOTO	$-.1
			CLRF PORTB
			BSF	CLK1	
			RETURN

DELAY2	MOVWF PORTB
			BCF	CLK2
			DECFSZ	DEL,1
			GOTO	$-.1
			CLRF PORTB
			BSF	CLK2
			RETURN

;********   FIRST  DISPLAY UNIT**************
SHOW	
		CALL 	RESET
		BSF CLK1
		MOVF	C0,0
		CALL DELAY
		MOVF	C1,0
		CALL DELAY
		MOVF	C2,0
		CALL DELAY
		MOVF	C3,0
		CALL DELAY
		MOVF	C4,0
		CALL DELAY
		MOVF	C5,0
		CALL DELAY
		MOVF	C6,0
		CALL DELAY
		MOVF	C7,0
		CALL DELAY
		MOVF	C8,0
		CALL	DELAY
		CLRF 	PORTB
		
;********   SECOND  DISPLAY UNIT**************
		CALL RESET
		BSF CLK2
		CALL	DELAY2
		MOVF	C9,0
		CALL DELAY2
		MOVF	C10,0
		CALL DELAY2
		MOVF	C11,0
		CALL DELAY2
		MOVF	C12,0
		CALL DELAY2
		MOVF	C13,0
		CALL DELAY2
		MOVF	C14,0
		CALL DELAY2
		MOVF	C15,0
		CALL   DELAY2
		MOVF	C16,0
		CALL DELAY2
		MOVF	C17,0
		CALL DELAY2
		CLRF PORTB
		RETURN


;**********  MOVE                 P I C 16 F 8 4 A             LETTERS *************

LOAD		MOVLW   B'00000110' ;P
		MOVWF	C0	
		MOVLW   B'00001001'
		MOVWF	C1
		MOVLW  B'00001001'
		MOVWF	C2
		MOVLW  B'00001001'
		MOVWF	C3
		MOVLW   B'11111110'
		MOVWF	C4
		MOVLW   B'00000000' ;BLANK
		MOVWF	C5	
		MOVLW   B'00000000';BLANK
		MOVWF	C6
		MOVLW  B'10000001' ;I
		MOVWF	C7
		MOVLW  B'10000001'
		MOVWF	C8
		MOVLW   B'11111111'
		MOVWF	C9	
		MOVLW   B'10000001'
		MOVWF	C10
		MOVLW  B'10000001'

		MOVWF	C11
		MOVLW   B'00000000' ;BLANK
		MOVWF	C12	
		MOVLW   B'00000000';BLANK
		MOVWF	C13
		MOVLW   B'01000010';C
		MOVWF	C14
		MOVLW   B'10000001' 
		MOVWF	C15
		MOVLW   B'10000001'
		MOVWF	C16
		MOVLW   B'10000001'
		MOVWF	C17	
		MOVLW   B'01111110'
		MOVWF	C18
		MOVLW   B'00000000' ;BLANK
		MOVWF	C19	
		MOVLW   B'00000000';BLANK
		MOVWF	C20
		MOVLW   B'10000000' ;1
		MOVWF	C21	
		MOVLW   B'10000000'
		MOVWF	C22
		MOVLW   B'11111111'
		MOVWF	C23
		MOVLW  B'10000010'
		MOVWF	C24
		MOVLW   B'10000100'
		MOVWF	C25
		MOVLW   B'00000000' ;BLANK
		MOVWF	C26	
		MOVLW   B'00000000';BLANK
		MOVWF	C27
		MOVLW  B'01111010'  ;6
		MOVWF	C28	
		MOVLW  B'10001001'	
		MOVWF	C29
		MOVLW  B'10001001'
		MOVWF	C30
		MOVLW  B'10001001'
		MOVWF	C31
		MOVLW  B'01111110' 
		MOVWF	C32


		MOVLW   B'00000000' ;BLANK
		MOVWF	C33	
		MOVLW   B'00000000';BLANK
		MOVWF	C34
		MOVLW   B'00001001' ;F
		MOVWF	C35	
		MOVLW   B'00001001'
		MOVWF	C36
		MOVLW   B'00001001'
		MOVWF	C37
		MOVLW  B'11111111'
		MOVWF	C38
		MOVLW   B'00000000'
		MOVWF	C39
		MOVLW   B'00000000' ;BLANK
		MOVWF	C40	
		MOVLW   B'00000000';BLANK
		MOVWF	C41
		MOVLW  B'01111110'  ;8
		MOVWF	C42	
		MOVLW  B'10001001'	
		MOVWF	C43
		MOVLW  B'10001001'
		MOVWF	C44
		MOVLW  B'10001001'
		MOVWF	C45
		MOVLW  B'01111110' 
		MOVWF	C46

		MOVLW   B'00000000' ;BLANK
		MOVWF	C47	
		MOVLW   B'00000000';BLANK
		MOVWF	C48
		MOVLW  B'00001000'  ;4
		MOVWF	C49	
		MOVLW  B'11111111'	
		MOVWF	C50
		MOVLW  B'00001010'
		MOVWF	C51
		MOVLW  B'00000100'
		MOVWF	C52
		MOVLW  B'00001000' 
		MOVWF	C53

		MOVLW   B'00000000' ;BLANK
		MOVWF	C54	
		MOVLW   B'00000000';BLANK
		MOVWF	C55
		MOVLW  B'11111110'  ;A
		MOVWF	C56	
		MOVLW  B'00001001'	
		MOVWF	C57
		MOVLW  B'00001001'
		MOVWF	C58
		MOVLW  B'00001001'
		MOVWF	C59
		MOVLW  B'11111110' 
		MOVWF	C60

		MOVLW   B'00000000' ;BLANK
		MOVWF	C61	
		MOVLW   B'00000000';BLANK
		MOVWF	C62
		MOVLW   B'00000000';BLANK
		MOVWF	C63
		RETURN
		
;******************** MOVING  ********************

RUN		MOVF	C0,0 
		MOVWF	C63
		MOVF	C1,0
		MOVWF	C0
		MOVF	C2,0
		MOVWF	C1
		MOVF	C3,0
		MOVWF	C2
		MOVF	C4,0
		MOVWF	C3
		MOVF	C5,0
		MOVWF	C4
		MOVF	C6,0
		MOVWF	C5
		MOVF	C7,0
		MOVWF	C6
		MOVF	C8,0
		MOVWF	C7
		MOVF	C9,0
		MOVWF	C8
		MOVF	C10,0
		MOVWF	C9

		MOVF	C11,0
		MOVWF	C10
		MOVF	C12,0
		MOVWF	C11
		MOVF	C13,0
		MOVWF	C12
		MOVF	C14,0
		MOVWF	C13
		MOVF	C15,0
		MOVWF	C14
		MOVF	C16,0
		MOVWF	C15
		MOVF	C17,0
		MOVWF	C16
		MOVF	C18,0
		MOVWF	C17
		MOVF	C19,0
		MOVWF	C18
		MOVF	C20,0
		MOVWF	C19

		MOVF	C21,0
		MOVWF	C20
		MOVF	C22,0
		MOVWF	C21
		MOVF	C23,0
		MOVWF	C22
		MOVF	C24,0
		MOVWF	C23
		MOVF	C25,0
		MOVWF	C24
		MOVF	C26,0
		MOVWF	C25
		MOVF	C27,0
		MOVWF	C26
		MOVF	C28,0
		MOVWF	C27
		MOVF	C29,0
		MOVWF	C28
		MOVF	C30,0
		MOVWF	C29

		MOVF	C31,0
		MOVWF	C30
		MOVF	C32,0
		MOVWF	C31
		MOVF	C33,0
		MOVWF	C32
		MOVF	C34,0
		MOVWF	C33
		MOVF	C35,0
		MOVWF	C34

		MOVF	C36,0
		MOVWF	C35
		MOVF	C37,0
		MOVWF	C36
		MOVF	C38,0
		MOVWF	C37
		MOVF	C39,0
		MOVWF	C38
		MOVF	C40,0
		MOVWF	C39
		MOVF	C41,0
		MOVWF	C40
		MOVF	C42,0
		MOVWF	C41
		MOVF	C43,0
		MOVWF	C42
		MOVF	C44,0
		MOVWF	C43
		MOVF	C45,0
		MOVWF	C44

		MOVF	C46,0
		MOVWF	C45
		MOVF	C47,0
		MOVWF	C46
		MOVF	C48,0
		MOVWF	C47
		MOVF	C49,0
		MOVWF	C48
		MOVF	C50,0
		MOVWF	C49

		MOVF	C51,0
		MOVWF	C50
		MOVF	C52,0
		MOVWF	C51
		MOVF	C53,0
		MOVWF	C52
		MOVF	C54,0
		MOVWF	C53
		MOVF	C55,0
		MOVWF	C54

		MOVF	C56,0
		MOVWF	C55
		MOVF	C57,0
		MOVWF	C56
		MOVF	C58,0
		MOVWF	C57
		MOVF	C59,0
		MOVWF	C58
		MOVF	C60,0
		MOVWF	C59

		MOVF	C61,0
		MOVWF	C60
		MOVF	C62,0
		MOVWF	C61
		MOVF	C63,0
		MOVWF	C62
		RETURN

;*********************************************************************	



MAIN	BSF	STATUS,RP0;B1
		CLRF	TRISB
		CLRF	TRISA
		BCF	STATUS,RP0

		MOVLW	0x07	; turn off comparators   *****************
		MOVWF	CMCON

		MOVLW	0Ch
		MOVWF FSR
		CLRF INDF
;*********	RAM CLEAR     ************
		INCF	FSR,1
		BTFSS	FSR,6
		GOTO	$-.3
		CALL LOAD
		

DISPLAY		MOVLW	.15
		MOVWF	TIME
		CALL	SHOW
		DECFSZ	TIME,1
		GOTO	$-.2
		CALL RUN
		GOTO  DISPLAY

;	ORG	2007h
 	ORG 2100
	DATA	3FF1h				
	END


